| AIfES 2 2.0.0

Data Structures | Typedefs | Functions
ailayer_elu_default.h File Reference

Default implementation of the ELU layer . More...

Go to the source code of this file.

## Data Structures
struct | ailayer_elu_f32
| Data-type specific ELU layer struct for F32 . More...
struct | ailayer_elu_q31
| Data-type specific ELU layer struct for Q31 . More...
struct | ailayer_elu_q7
| Data-type specific ELU layer struct for Q7 . More...

## Typedefs
typedef struct ailayer_elu_f32 | ailayer_elu_f32_t
typedef struct ailayer_elu_q31 | ailayer_elu_q31_t
typedef struct ailayer_elu_q7 | ailayer_elu_q7_t

## Functions
ailayer_t * | ailayer_elu_f32_default (ailayer_elu_f32_t *layer, ailayer_t *input_layer)
| Initializes and connect an ELU layer with the F32 default implementation. More...
ailayer_t * | ailayer_elu_q31_default (ailayer_elu_q31_t *layer, ailayer_t *input_layer)
| Initializes and connect a ELU layer with the Q31 default implementation. More...
ailayer_t * | ailayer_elu_q7_default (ailayer_elu_q7_t *layer, ailayer_t *input_layer)
| Initializes and connect a ELU layer with the Q7 default implementation. More...
void | ailayer_elu_calc_result_tensor_params_q31_default (ailayer_t *self)
| Calculate and set the quantization parameters for the result tensor of the ELU Q31 default implementation. More...
void | ailayer_elu_calc_result_tensor_params_q7_default (ailayer_t *self)
| Calculate and set the quantization parameters for the result tensor of the ELU Q7 default implementation. More...

## Detailed Description

Default implementation of the ELU layer .

Version
  2.2.0

Copyright
  Copyright (C) 2020-2023 Fraunhofer Institute for Microelectronic Circuits and Systems. All rights reserved.
  AIfES is free software: you can redistribute it and/or modify it under the terms of the GNU Affero General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Affero General Public License for more details.
  You should have received a copy of the GNU Affero General Public License along with this program. If not, see https://www.gnu.org/licenses/.

Hardware independent implementations of the ELU layer in F32 data-type. For more information about the ELU layer refer to ailayer_elu.h.

## Function Documentation

## ◆ ailayer_elu_calc_result_tensor_params_q31_default()

void ailayer_elu_calc_result_tensor_params_q31_default | ( | ailayer_t * | self | ) |

Calculate and set the quantization parameters for the result tensor of the ELU Q31 default implementation.

Implementation of ailayer.calc_result_tensor_params.

The quantization parameters are pre-defined and the same as in the corresponding math function aimath_q31_default_elu().

Parameters

  *self | The layer structure

## ◆ ailayer_elu_calc_result_tensor_params_q7_default()

void ailayer_elu_calc_result_tensor_params_q7_default | ( | ailayer_t * | self | ) |

Calculate and set the quantization parameters for the result tensor of the ELU Q7 default implementation.

Implementation of ailayer.calc_result_tensor_params.

The quantization parameters are pre-defined and the same as in the corresponding math function aimath_q7_default_elu().

Parameters

  *self | The layer structure

## ◆ ailayer_elu_f32_default()

ailayer_t* ailayer_elu_f32_default | ( | ailayer_elu_f32_t * | layer,
|  | ailayer_t * | input_layer
| ) |  |

Initializes and connect an ELU layer with the F32 default implementation.

Example: Create the layer structure:
In C:

ailayer_elu_f32_t elu_layer = {
.alpha = 1.0f
};
ailayer_elu_f32
Data-type specific ELU layer struct for F32 .
Definition: ailayer_elu_default.h:49
ailayer_elu_f32::alpha
aiscalar_f32_t alpha
Data-type specific parameter used to calculate ELU function for input values < 0.
Definition: ailayer_elu_default.h:51

In C, C++ and on Arduino:

ailayer_elu_f32_t elu_layer = AILAYER_ELU_F32_A(1.0f);

Example: Initialize and connect the layer:

x = ailayer_elu_f32_default(&elu_layer, x);
ailayer_elu_f32_default
ailayer_t * ailayer_elu_f32_default(ailayer_elu_f32_t *layer, ailayer_t *input_layer)
Initializes and connect an ELU layer with the F32 default implementation.

Parameters

  *layer | The layer structure to initialize.
  *input_layer | The prior layer.

Returns
  The (successfully) initialized layer structure.

## ◆ ailayer_elu_q31_default()

ailayer_t* ailayer_elu_q31_default | ( | ailayer_elu_q31_t * | layer,
|  | ailayer_t * | input_layer
| ) |  |

Initializes and connect a ELU layer with the Q31 default implementation.

The quantization parameters of the result tensor are automatically set to {shift = input_layer.result.shift, zero_point = input_layer.result.zero_point} because the output values are in the interval (max(-alpha, min(input_layer.result)), max(input_layer.result)].

Example: Create the layer structure:
In C:

ailayer_elu_q31_t elu_layer = {
.alpha = AISCALAR_Q31(1.0f, 2, 0)
};
ailayer_elu_q31
Data-type specific ELU layer struct for Q31 .
Definition: ailayer_elu_default.h:58
ailayer_elu_q31::alpha
aiscalar_q31_t alpha
Data-type specific parameter used to calculate ELU function for input values < 0.
Definition: ailayer_elu_default.h:60

In C, C++ and on Arduino:

ailayer_elu_q31_t elu_layer = AILAYER_ELU_Q31_M(AISCALAR_Q31(1.0f, 2, 0));

Example: Initialize and connect the layer:

x = ailayer_elu_q31_default(&elu_layer, x);
ailayer_elu_q31_default
ailayer_t * ailayer_elu_q31_default(ailayer_elu_q31_t *layer, ailayer_t *input_layer)
Initializes and connect a ELU layer with the Q31 default implementation.

Parameters

  *layer | The layer structure to initialize.
  *input_layer | The prior layer.

Returns
  The (successfully) initialized layer structure.

## ◆ ailayer_elu_q7_default()

ailayer_t* ailayer_elu_q7_default | ( | ailayer_elu_q7_t * | layer,
|  | ailayer_t * | input_layer
| ) |  |

Initializes and connect a ELU layer with the Q7 default implementation.

The quantization parameters of the result tensor are automatically set to {shift = input_layer.result.shift, zero_point = input_layer.result.zero_point} because the output values are in the interval (max(-alpha, min(input_layer.result)), max(input_layer.result)].

Example: Create the layer structure:
In C:

ailayer_elu_q7_t elu_layer = {
.alpha = AISCALAR_Q7(1.0f, 2, 0)
};
ailayer_elu_q7
Data-type specific ELU layer struct for Q7 .
Definition: ailayer_elu_default.h:67
ailayer_elu_q7::alpha
aiscalar_q7_t alpha
Data-type specific parameter used to calculate ELU function for input values < 0.
Definition: ailayer_elu_default.h:69

In C, C++ and on Arduino:

ailayer_elu_q7_t elu_layer = AILAYER_ELU_Q7_M(AISCALAR_Q7(1.0f, 2, 0));

Example: Initialize and connect the layer:

x = ailayer_elu_q7_default(&elu_layer, x);
ailayer_elu_q7_default
ailayer_t * ailayer_elu_q7_default(ailayer_elu_q7_t *layer, ailayer_t *input_layer)
Initializes and connect a ELU layer with the Q7 default implementation.

Parameters

  *layer | The layer structure to initialize.
  *input_layer | The prior layer.

Returns
  The (successfully) initialized layer structure.